/* some of the longer help texts */

static char file_menu_help[] =
"  Open: open a file.\n\
  Close: close the currently selected file.\n\
  Save: save any edits on the current file.\n\
  Save as: save edits on the current file,\n\
      in some new file.\n\
  Revert: undo any edits on the current file.\n\
  Mix: mix in a file.\n\
  Update: reload current sound from disk.\n\
  New: create an empty sound edit window.\n\
  View: open a file in read-only mode.\n\
  Print: produce graph as Postscript file.\n\
  Exit: leave Snd, without saving any edits.\n\
";

char *get_file_menu_help(void) {return(file_menu_help);}


static char edit_menu_help[] =
"  Undo: undo the last edit in the current file.\n\
  Redo: redo the undone edit.\n\
  Find: a global search -- operates across all\n\
     currently sync'd sounds.\n\
  Cut: store, then delete the selection.\n\
  Paste: insert the selection at the current location\n\
  Mix selection: add the selection at the current location\n\
  Play selection: play the current selection.\n\
  Save selection: save the current selection in a file.\n\
  Edit Envelope: start the envelope editor dialog.\n\
";

char *get_edit_menu_help(void) {return(edit_menu_help);}

static char view_menu_help[] =
"  Show Controls: display the control pane.\n\
  Normalize: During editing with multiple\n\
     files and channels, some data may be\n\
     obscured or compressed by changed window\n\
     sizes.  Normalize returns Snd to a state\n\
     where everything is equally compressed.\n\
  Combine channels: combine all channels into\n\
     one graph.\n\
  Info: describe current sound file format.\n\
  Dots: display data as dots; the other\n\
     option is the default Lines.\n\
  Show Marks: display mark locations using a\n\
     long vertical line.\n\
  Show Y=0: display the y=0 line.\n\
  Verbose cursor: show cursor loc and sample value.\n\
  Regions: fire up the region browser.\n\
  Files: fire up the file browser.\n\
  Color: color browser for sonogram.\n\
  Orientation: sonogram orientation.\n\
  Hide consoles: currently unimplemented.\n\
  X axis units: x axis labels in seconds, samples, ect.\n\
";

char *get_view_menu_help(void) {return(view_menu_help);}


static char options_menu_help[] = 
"  FFT Size: set the size of the fft (a power of 2).\n\
   Show Peaks: show fft peaks. The higher peaks are\n\
      in bold face.\n\
   FFT log freq: display the fft data using log x axis.\n\
   FFT in dB: display the fft data in dB.\n\
   FFT Style: display sonogram or single FFT.\n\
   Speed style: control panel speed scrollbar interpretation.\n\
   Zoom focus: where to focus during zooms.\n\
   Subsampling off: When large amounts of data are\n\
      being displayed, Snd may subsample the data to\n\
      speed up the display process.  This can introduce\n\
      artifacts of the sampling interval on rare occasions.\n\
   Save Options: save the current Options and View menu settings.\n\
   FFT Window: set the fft window choice.\n\
   FFT Beta: if relevant to the fft window, set the\n\
      associated window parameter, sometimes called beta.\n\
   Session: load or save session.\n\
   Transform type: Fourier, Wavelet, Polynomial etc.\n\
\n\
";

char *get_options_menu_help(void) {return(options_menu_help);}

static char help_menu_help[] =   
"  Click for Help: if you choose this, the\n\
      mouse cursor becomes a '?'; position\n\
      the cursor over the portion of the Snd\n\
      window that interests you, and click\n\
      the button.\n\
  About Snd: this text.\n\
  FFT: a discussion of Snd's FFT options.\n\
  Find: how to perform searches.\n\
  Undo/Redo: how to back up while editing.\n\
  Sync: how to perform multichannel operations.\n\
  Speed: how to change sampling rate.\n\
  Expand: how to change tempo.\n\
  Reverb: how to reverberate.\n\
  Contrast: how to add contrast enhancement.\n\
  Envelope: how to apply an envelope.\n\
  Marks: about marks in Snd.\n\
  Mixing: about mixing in Snd (mostly unimplemented).\n\
  Formats: Snd-supported formats and headers.\n\
  Customization: how to customize Snd.\n\
  User functions: how to add your own functions to Snd.\n\
";

char *get_help_menu_help(void) {return(help_menu_help);}


static char about_snd_help[] = 
"Snd is a sound editor. See snd.html or snd.txt for\n\
full details.  Please send bug reports or suggestions to\n\
bil@ccrma.stanford.edu.\n\
\n\
To get started, go to the File menu, and\n\
open a sound file.  To hear the sound, click\n\
the 'play' button. To see an fft, click the\n\
'f' button on the left.  The left mouse button\n\
is used for most pointing operations; the\n\
middle button pastes in the current selection;\n\
the right button brings up the Snd popup menu.\n\
\n\
";

char *get_about_snd_help(void) {return(about_snd_help);}


static char graph_help[] =
"  [Down] zoom out, amount depends on state keys\n\
  [Up] zoom in\n\
  [Left] move window left, amount depends on state keys\n\
  [Right] move window right\n\
  <:   move cursor to sample 0\n\
  >:   move cursor to last sample\n\
  c-<: move cursor to sample 0\n\
  c->: move cursor to last sample\n\
  c-a: move cursor to window start\n\
  c-b: move cursor back one sample\n\
  c-d: delete sample at cursor\n\
  c-e: move cursor to window end\n\
  c-f: move cursor ahead one sample\n\
  c-g: abort current command\n\
  c-h: repeat external function call\n\
  c-i: display cursor info\n\
  c-j: goto mark\n\
  c-k: delete one line's worth of samples\n\
  c-l: position window so cursor is in the middle\n\
  c-m: place (or remove) mark at cursor location\n\
  c-n: move cursor ahead one 'line'\n\
  c-o: insert one zero sample at cursor\n\
  c-p: move cursor back one 'line'\n\
  c-q: play current channel starting at cursor\n\
  c-r: repeat last search backwards\n\
  c-s: search according to an expression\n\
       'y' is the current sample value,\n\
       'y(n) is the value of the sample n from the current\n\
       the find expression syntax is C-like and\n\
       supports much of C and its math library.\n\
       c-s y>.1 finds the next sample greater than .1\n\
  c-t: stop playing\n\
  c-u: start count definition.  If followed by a\n\
       float, the actual count is that number multiplied\n\
       by the current sampling rate.  If the optional\n\
       number is followed by c-m, the count returned\n\
       is the distance from the cursor to the n-th\n\
       successive mark.  That is, c-u c-m c-f is the\n\
       same as c-j.\n\
  c-v: move cursor to mid-window\n\
  c-w: delete current region\n\
  c-x: start extended command (see below)\n\
  c-y: paste in last deleted region. Use c-u\n\
       to paste in earlier regions.\n\
  c-z: set sample at cursor to 0.0\n\
  c-_: undo\n\
  c-[Space]: start region definition\n\
       - c-[Space] to remove region\n\
\n\
The extended commands (preceded by c-x) are:\n\
  a: apply envelope to selection\n\
  b: position window so cursor is on left margin\n\
  c: define selection from cursor to nth mark\n\
  d: set temp dir name\n\
  e: execute last keyboard macro\n\
  f: position window so cursor is on right margin\n\
  h: apply external function to selection\n\
  i: insert region\n\
  j: goto named mark\n\
  k: close file\n\
  l: position selection in mid-view\n\
  n: re-evaluate expression over selection\n\
  o: move to next or previous graph\n\
  p: play selection or region n\n\
  q: mix in region\n\
  r: redo last undone edit\n\
  u: undo last edit\n\
  v: position window over current selection\n\
  w: save selection as file\n\
  x: evaluate expression over selection\n\
  y: get and apply external function to selection\n\
  z: smooth selection\n\
  /: place named mark\n\
  (: begin keyboard macro definition\n\
  ): end keyboard macro definition\n\
\n\
  c-a: apply envelope.  If a count is specified,\n\
     the envelope is applied from the cursor for\n\
     that number of samples.  Otherwise, the\n\
     envelope is applied to the entire file, and\n\
     if syncing is on, all sync'd channels.\n\
  c-b: set x window bounds (preceded by 1 arg)\n\
  c-c: hide controls\n\
  c-d: print\n\
  c-e: give last keyboard macro a name\n\
  c-f: open file\n\
  c-g: abort command\n\
  c-h: external function call\n\
  c-i: insert file\n\
  c-l: load user function\n\
  c-m: add named mark\n\
  c-n: re-evaluate expression\n\
  c-o: show controls\n\
  c-p: set window size (preceded by 1 arg)\n\
  c-q: mix in file\n\
  c-r: redo last undone edit\n\
  c-s: save file\n\
  c-u: undo last edit\n\
       Snd supports 'unlimited undo/redo'\n\
  c-v: set window size as percentage of total\n\
  c-w: save current channel in file\n\
  c-y: set up auto-call of external function\n\
  c-x: evaluate expression\n\
  c-z: smooth using cosine\n\
\n\
Unless otherwise noted, case is not significant;\n\
c-a is the same as c-A.\n\
\n\
Most commands can be prefaced by an integer or\n\
a float; the integer causes the command to be repeated\n\
that many times; the float is multiplied by the\n\
sound's sampling rate, then applied that many times.\n\
So, for example, c-u 1.0 c-f causes the cursor to move\n\
ahead one second in the sound.\n\
\n\
The y-axis limit (default = 1.0) can be set\n\
in the minibuffer via the variable 'y_max'.\n\
\n\
A named macro can be invoked with M-x; M-x save-macros\n\
saves the current named macros; M-x save-macro mac\n\
saves one macro named 'mac'; both put the macro\n\
definition in the Snd initialization file, normally '.snd'.\n\
\n\
";

char *get_graph_help(void) {return(graph_help);}

static char fft_keypad_help[] = 
"The keypad keys are mapped to various variables as follows:\n\
\n\
    variable         increase           decrease\n\
  sono_max          PageUp (9)          PageDown (3)\n\
  spectro_hop       Add (+)             Subtract (-)\n\
  spectro_zangle    RightArrow (6)      LeftArrow (4)\n\
  spectro_xangle    Ctrl-UpArrow (8)    Ctrl-DownArrow (2)\n\
  spectro-yangle    Ctrl-RightArrow (6) Ctrl-LeftArrow (4)\n\
  spectro_zscl      UpArrow (8)         DownArrow (2)\n\
  fft_size          Multiply (*)        Divide (/)\n\
  dot_size          Delete (.)          Insert (0)\n\
\n\
You can rotate the spectrogram around the various axes\n\
by holding down the keypad and control keys.  You can get\n\
arbitrarily small or large ffts with the Multiply and\n\
Divide keys.  The x and y axis scalres are named\n\
spectro_xscl and spectro_yscl; they can be set via\n\
C-X C-X.  The keypad Enter key resets all the\n\
spectrogram variables to their default values.\n\
(In Linux, use the corresponding numbered keys --\n\
add shift to the key sequences given above).\n\
See also the Color and Orientation menu options\n\
in the View menu.\n\
\n\
";

char *get_fft_keypad_help(void) {return(fft_keypad_help);}

static char fft_menu_help[] = 
"The FFT performs a projection of the\n\
time domain into the frequency domain.\n\
Good discussions of the Fourier Transform\n\
and the trick used in the FFT itself\n\
can be found in many DSP books; those\n\
I know of include 'A Digital Signal Processing\n\
Primer', Ken Steiglitz, Addison-Wesley,\n\
1996; or 'Numerical Recipes in C', mentioned\n\
below.\n\
\n\
The FFT size can be any power of 2. The\n\
larger, the longer it takes to compute,\n\
and the larger the amount of the time domain\n\
that gets consumed.  Interpretation of the\n\
FFT results is not straightforward!\n\
\n\
The window choices are taken primarily\n\
from Harris' article.\n\
\n\
  Fredric J. Harris, 'On the Use of Windows\n\
     for Harmonic Analysis with the Discrete\n\
     Fourier Transform', Proceedings of the\n\
     IEEE, Vol. 66, No. 1, January 1978.\n\
\n\
with updates from:\n\
\n\
  Albert H. Nuttall, 'Some Windows with Very\n\
     Good Sidelobe Behaviour', IEEE Transactions\n\
     of Acoustics, Speech, and Signal Processing,\n\
     Vol. ASSP-29, 1, February 1981.\n\
\n\
Some of the windows take an additional parameter\n\
sometimes known as alpha or beta.  This is set\n\
in Snd by the FFT Beta menu.  The FFT display\n\
is activated by setting the 'f' button on the\n\
channel's window.  It then updates itself each\n\
time the time domain waveform moves or changes.\n\
The update function runs in the background, so\n\
in some cases, notably very large FFTs, you will\n\
notice that the FFT updates less often than the\n\
time domain.\n\
\n\
To display the y axis in dB, use the FFT in dB\n\
menu option; similarly to get a logarithmic x\n\
axis, use the FFT Log Freq menu choice.\n\
\n\
To get a sonogram display, rather than a simple\n\
FFT, use the Sonogram option in the FFT Style menu.\n\
\n\
All the FFT choices can be set at initialization\n\
time by setting the appropriate variable in the\n\
init file (normally named '.snd' and placed on\n\
your home directory).  The relevant variables\n\
with example (the default) settings are:\n\
\n\
(setf fft-size 256)\n\
(setf fft-window 6) ;Blackman order 2\n\
  ;; see snd-fft.c for the complete list\n\
(setf fft-beta 2.5)\n\
(hide-fft)          ;(show-fft) to turn fft on\n\
(fft-linear)        ;(fft-dB) for dB\n\
(fft-linear-freq)   ;(fft-log-freq) for log freq\n\
(fft-style 0)       ;1=sonogram, 2=spectrogram\n\
(setf normalize-fft 1)\n\
sono_max = 1.0      ;1.0 corresponds to srate/2\n\
\n\
The spectrum data is usually normalized to fit\n\
between 0.0 to 1.0; if you'd rather have un-normalized\n\
data (the y-axis in this case changes to reflect the\n\
data values, to some extent), set the variable\n\
normalize-fft to 0.\n\
\n\
The actual FFT algorithm used here is the\n\
'realft' function from 'Numerical Recipes in C',\n\
by Press et al, Cambridge Univ Press, 1989.\n\
\n\
The harmonic analysis function is normally the\n\
Fourier Transform, but others are available,\n\
including about 20 wavelet choices, the Hankel and\n\
Chebyshev transforms, and perhaps others.\n\
\n\
";

char *get_fft_menu_help(void) {return(fft_menu_help);}

static char find_menu_help[] = 
"Searches in Snd refer to the sound data, and are\n\
in general patterned after Emacs.  When you type\n\
c-s or c-r, the minibuffer below the graph is\n\
activated and you are asked for the search expression.\n\
The expression is a piece of C-like code that describes\n\
which sample satisifies the search.  For example,\n\
to look for the next sample that is greater than\n\
.1, we could type: y>.1.  The cursor then moves\n\
to the next such sample, if any.  Successive c-s\n\
or c-r repeat the search.  c-x c-s can redefine the\n\
search pattern, which is also cleared in other\n\
events, much like Emacs.\n\
\n\
The search (and c-x c-x eval) expression\n\
syntax includes most of C's operators, and the\n\
standard math library, as well as many variables\n\
internal to Snd.  To get at the current sample's\n\
value, use 'y'.  'y(n)' refers to the sample\n\
n samples from the current one. 'x' is the current\n\
sample number. 'samples' is the total number of\n\
samples.\n\
\n\
Normally, the search applies only to the current channel.\n\
To search\n\
all current files at once, use the Edit menu's\n\
find option.\n\
\n\
";

char *get_find_menu_help(void) {return(find_menu_help);}

static char expression_help[] = 
"The C operators implemented are:\n\
\n\
+ - * / > >= < <= == != ( ) { }\n\
=+ *= /= -= = || && ? : !\n\
\n\
The math library functions included are:\n\
\n\
log log10 exp cos sin abs (i.e. fabs)\n\
pow sqrt atan acos asin cosh sinh tanh fmod\n\
ceil floor\n\
\n\
Variables can be defined with 'float'.\n\
\n\
Snd-internal variables that are accessible\n\
in these expressions include:\n\
\n\
  auto_open      force open window upon activation\n\
  explen:        segment length in expand\n\
  exprmp:        ramp size in expand\n\
  exphop:        hop size in expand\n\
  revfb:         reverb volume\n\
  y_max:         y axis bounds\n\
  revlp:         reverb feedback low-pass coefficient\n\
  x:             cursor sample number\n\
  y:             value at cursor (y(n) also)\n\
  samples:       current length of channel\n\
  srate:         current srate of file\n\
  x_max:         x axis bounds\n\
  color_scale:   darkness setting\n\
  color_cutoff:  small values ignored?\n\
  revdecay:      length(secs) of reverb decay\n\
  line_size:     length of a 'line' (for C-p etc)\n\
  contrast_amp:  scaler on contrast input\n\
  fft_size:      fft size\n\
  sono_max:      sonogram y axis limit\n\
  sono_color:    sonogram color set (0..4)\n\
  spectro_color: spectrogram color set (-1..4)\n\
  spectro_hop:   density of spectrogram traces\n\
  spectro_xangle:viewing angle of spectrogram (also spectr_yangle,spectro_zangle)\n\
  spectro_zscl:  height of peaks in spectrogram (also spectro_xscl, spectro_yscl)\n\
  dot_size:      size of graph dots\n\
  pi:            3.14159...\n\
\n\
";

char *get_expression_help(void) {return(expression_help);}


static char undo_menu_help[] = 
"Snd supports unlimited undo in the\n\
sense that you can backup through all\n\
the edits since the last save, and at\n\
any point redo those edits.  Certain\n\
operations require that temporary files\n\
be written, so disk space may eventually\n\
become a problem.  Revert is the same\n\
as backing up to the last save.\n\
\n\
In addition, eight or so of the previous\n\
selections are saved on a stack accessible\n\
via c-y.\n\
\n\
";

char *get_undo_menu_help(void) {return(undo_menu_help);}


static char sync_menu_help[] = 
"The sync button causes certain operations to\n\
apply to all channels simultaneously.  In mono\n\
sounds, the sync button has a similar effect,\n\
but applied across multiple sounds.\n\
\n\
To get multi-channel selections, set the sync\n\
button, then define the selection (by dragging\n\
the mouse) in one channel, and the parallel\n\
portions of the other channels will also be\n\
selected.\n\
\n\
Currently the sync-able operations include\n\
those that move the cursor, reset or resize\n\
the graph bounds, make or paste selections,\n\
or perform searches.\n\
\n\
";

char *get_sync_menu_help(void) {return(sync_menu_help);}


static char speed_menu_help[] = 
"'Speed' here refers to the rate at which the\n\
sound data is consumed during playback.\n\
Another term might be 'srate'.  Snd uses\n\
linear interpolation to perform the speed\n\
change.  The arrow button on the right determines\n\
the direction we move through the data.\n\
The scroll bar position is normally interpreted\n\
as a float between .05 and 20.  The Options\n\
Speed Style menu (or the speed-style variable)\n\
can change this to use semitones (actually microtones)\n\
or just-intonation ratios.  The number of equal\n\
divisions to the octave in the semitone case is\n\
set by the variable speed-tones (normally 12).\n\
\n\
";

char *get_speed_menu_help(void) {return(speed_menu_help);}


static char expand_menu_help[] = 
"'Expand' here refers to a kind of granular\n\
synthesis used to change the tempo of events\n\
in the sound without changing pitch.  Successive\n\
short slices of the file are overlapped with\n\
the difference in size between the input and\n\
output hops (between successive slices) giving\n\
the change in tempo.  This doesn't work in all\n\
files -- it sometimes sounds like execrable reverb\n\
or is too buzzy -- but it certainly is more\n\
robust than the phase vocoder approach to the\n\
same problem.  The phase vocoder NEVER works!\n\
\n\
There are a variety of variables that control\n\
hop sizes, segment lengths, and overall segment\n\
envelopes.  These can be set in the minibuffer\n\
via c-x c-x, or in your Snd init file.  In the\n\
former, the syntax is C-like; in the latter,\n\
Lisp-like.  The variables are:\n\
\n\
  exprmp: the length of the ramp up (.4, 0 to .5)\n\
  explen: the length of each slice (.15)\n\
  exphop: the hop size (.05)\n\
\n\
The expander is on only if the expand\n\
button is set.\n\
\n\
";

char *get_expand_menu_help(void) {return(expand_menu_help);}


static char reverb_menu_help[] = 
"The Snd reverberator is a version of Michael\n\
McNabb's Nrev.  In addition to the controls\n\
in the control pane, you can set the reverb\n\
feedback gains and the coefficient of the low\n\
pass filter in the allpass bank. The variables\n\
are 'revfb' and 'revlp'.  The reverb is on only\n\
if the reverb button is set.\n\
";
char *get_reverb_menu_help(void) {return(reverb_menu_help);}


static char contrast_menu_help[] = 
"'Contrast enhancement' is my name for this\n\
somewhat weird waveshaper or compander.  It\n\
phase-modulates a sound, which can in some\n\
cases make it sound sharper or brighter.\n\
For softer sounds, it causes only an amplitude\n\
change.  Contrast is on only if the contrast\n\
button is set.\n\
\n\
";
char *get_contrast_menu_help(void) {return(contrast_menu_help);}


static char env_menu_help[] = 
"An envelope in Snd is a sequence of x y\n\
break-point pairs. The x axis range is\n\
arbitrary. For example, to define a triangle\n\
curve: '0 0 1 1 2 0'. There is no (obvious) limit\n\
on the number of breakpoints.\n\
\n\
To apply an envelope to a sound, use the extended\n\
command C-x C-a. If this command gets a numeric\n\
argument, the envelope is applied from the cursor\n\
for that many samples.\n\
\n\
  C-x a     apply amplitude envelope to selection\n\
  C-x C-a   apply amplitude envelope to channel\n\
\n\
You can also specify a envelope name to the C-x C-a\n\
prompt. The corresponding M-x commands are:\n\
\n\
  amp-env beg dur scaler env ;beg and dur in samples, env=breakpoints\n\
  amp-envelope env           ;applies from sample 0 to end, scaler=1.0\n\
  selection-amp-envelope env ;same but applied to all of selection\n\
\n\
M-x (amp-envelope 0 1 1 0 2 1), for example, ramps\n\
the sound down to 0 in its middle, then ramps back\n\
up to the original by the end.\n\
\n\
To scale a file or selection by or to some\n\
amplitude, use the M-x commands:\n\
\n\
  scale-by args\n\
  scale-to args\n\
  scale-selection-by args\n\
  scale-selection-to args\n\
\n\
scale-by scales the current sync'd channels by its\n\
arguments, and scale-to scales them to its\n\
arguments (a normalization). The arguments in\n\
each case are either a list of floats\n\
corresponding to each successsive member of the\n\
current set of sync'd channels, or just one\n\
argument. In the latter case, scale-by uses that\n\
scaler for all its channels, and scale-to\n\
normalizes all the channels together so that the\n\
loudest reaches that amplitude (that is, scale-to\n\
.5) when applied to a stereo file means that both\n\
channels are scaled by the same amount so that the\n\
loudest point in the file becomes .5).\n\
";
char *get_env_menu_help(void) {return(env_menu_help);}


static char format_menu_help[] = 
"Snd can read and write any of the sound\n\
file data and header formats that CLM can\n\
handle:\n\
\n\
Supported read/write:\n\
  NeXT/Sun/DEC/AFsp 8-bit mulaw and alaw, 8, 16, 24, 32-bit linear, 32, 64-bit float\n\
  AIFF 8, 16, 24, 32-bit linear, 8-bit mulaw and alaw (AIFC in these cases)\n\
  RIFF ('wave') 16-bit linear, 8-bit unsigned, 32-bit linear, 8-bit mulaw, 8-bit alaw\n\
  IRCAM (old style) 16-bit linear, 32-bit float, 8-bit mulaw and alaw\n\
  no header, many data formats\n\
\n\
Supported read-only:\n\
  8SVX 8-bit linear, 16-bit linear\n\
  IRCAM 32-bit Vax float\n\
  EBICSF, INRS, ESPS, SPPACK, ADC (OGI) 16-bit linear\n\
  NIST-SPHERE 16-bit linear, 8-bit mulaw and alaw\n\
  AVR 16-bit linear and unsigned, 8-bit linear and unsigned\n\
  VOC 8-bit unsigned, 16-bit linear\n\
  Sound Tools 8-bit unsigned, PSION alaw, MAUD 8/16 bit\n\
  Turtle Beach SMP, SoundFont 2.0 16-bit linear\n\
  Sound Designer I, Tandy DeskMate 8-bit unsigned\n\
  Gravis Ultrasound 16-bit unsigned, Comdisco SPW\n\
  Goldwave sample, Sonic Foundry, DiamondWare\n\
  CSRE adf, SBStudio II, Delusion, Farandole\n\
  Ultratracker, Sample Dump, Digiplayer, Yamaha\n\
\n\
Translated automatically:\n\
  IEEE text, Mus10 SAM 16-bit (modes 1 and 4)\n\
  IBM CVSD, HCOM, NIST shortpack, AVI\n\
  MIDI sample dump, Intel and Dialogic ADPCM\n\
\n\
'Linear' here means 2's complement integer.\n\
The files can have any number of channels.\n\
Data can be either big or little endian.\n\
\n\
When edits are saved, files in the first\n\
group are changed in place; those in the second\n\
group are changed to use one of the first\n\
group's headers (normally NeXT); those in\n\
the third group are translated when opened\n\
and an new (perhaps redundant) '.snd' extension\n\
is added to distinguish the original from the\n\
translated form; the latter is then treated\n\
as the original by the editor.\n\
\n\
";

char *get_format_menu_help(void) {return(format_menu_help);}


static char info_help[] = 
"This is the 'minibuffer', to use Emacs\n\
jargon.  Although it looks inert and wasted,\n\
there is in fact a text window lurking beneath\n\
that has access to a C-syntax evaluator, not\n\
to mention much of the innards of the Snd program.\n\
Click on the middle of the empty portion, and\n\
type some expression like '3+2'. It will report\n\
'3+2 => 5.0', which, given that it knows only\n\
floats, is not surprising.\n\
\n\
The minbuffer comes to life in many situations\n\
where information is needed to continue, but a\n\
fancy dialog window struck me as silly.\n\
\n\
";

char *get_info_help(void) {return(info_help);}


static char play_help[] =
"Snd can play any number of sounds at once\n\
or should be able to anyway.  A sort of\n\
clumsy realtime mixer, although it was not\n\
intended to fill that role. \n\
\n\
";

char *get_play_help(void) {return(play_help);}


static char mark_help[] = 
"A mark in Snd is attached to a particular\n\
sample in the sound data.  It moves with that\n\
sample as you edit the data, and if the sample\n\
is deleted, so is its mark.  Marks also follow\n\
the undo/redo edit history -- I'm not sure this\n\
is a good idea, but it seemed more intuitive\n\
than other alternatives.  This means that marks\n\
are 'undone' and 'redone' alongside the edits\n\
that they accompany.\n\
\n\
The mark symbol itself has three or four\n\
parts.  The name, if any, is at the top.\n\
Then a 'tab'.  You can click the name or\n\
tab portion and drag the mark to redefine it.\n\
Then a line to the bottom of the graph, showing\n\
where the mark is. And, below the x axis, an\n\
arrow.  You can click and drag the arrow to\n\
play the data following the mouse -- sort of\n\
like listening to a tape as you rock it back\n\
and forth by hand on the spindles. Or just\n\
click the arrow to play the data starting\n\
at the mark.\n\
\n\
";

char *get_mark_help(void) {return(mark_help);}


static char init_file_help[] =
"Nearly everything in Snd can be set in an\n\
initialization file, read after a system crash\n\
from an automatically generated backup file,\n\
loaded any time from a session file, specified\n\
via inter-process communciation from any other\n\
program, invoked via M-x, or imbedded in a\n\
macro. The syntax used is lisp-like; the point of\n\
view adopted here will be that of someone writing\n\
an intialization file to customize his version of\n\
Snd. The same syntax is used in the backup file\n\
(normally called .snd-backup), the\n\
initialization file (normally called ~/.snd),\n\
the IPC channel (see snd-test.cl for an example\n\
of the latter), macro definitions, and session\n\
files. The commands that Snd recognizes in these\n\
contexts are:\n\
\n\
          ;; File Menu\n\
 (open file)              ;open file read/write\n\
 (close file)             ;close file, add to previous files list\n\
 (save file)              ;save current edits to file\n\
 (save-as file1 file2)    ;save current state of file1 as file2\n\
 (revert file)            ;cancel edits, if any, to file\n\
 (view file)              ;open file read-only\n\
 (new)                    ;create new (empty) file\n\
 (print)                  ;print current graphs\n\
 (exit)                   ;exit Snd\n\
\n\
          ;; Edit Menu\n\
 (undo n)                 ;undo last n edits in current channel\n\
 (redo n)                 ;redo last n undone edits in current channel\n\
 (find expr)              ;find sample that satisfies expr\n\
 (cut)                    ;delete selected data, add to region stack\n\
 (paste n)                ;paste region n at current cursor position\n\
 (play file) (stop file)  ;play or stop playing file\n\
\n\
          ;; View Menu\n\
 (show-marks) (hide-marks);show or hide marks\n\
 (show-y-zero)            ;show or\n\
   (hide-y-zero)          ;  hide the y=0 line (normally hidden)\n\
 (dots) (lines)           ;show waveforns using dots or lines\n\
                          ;dot-size variable (keypad '.') sets size of dot\n\
 (unite) (separate)       ;combine or separate channels in multi-channel sounds\n\
 (normalize)              ;normalize Snd display\n\
 (info)                   ;show sound type, header comment etc\n\
 (show-controls)          ;show or\n\
   (hide-controls)        ;  hide the control panel\n\
 (show-consoles)          ;show or\n\
   (hide-consoles)        ;  hide the mini-mix control panels\n\
\n\
          ;; Options Menu\n\
 (show-peaks) (hide-peaks);fft display can include peaks\n\
 (peaks)                  ;place peak data in text window\n\
 (fft-style n)            ;0=normal, 1=sonogram, 2=spectrogram\n\
 (focus-style n)          ;0=window left, 1=window right,\n\
                          ;2=active entity (cursor or region), 3=window middle\n\
 (fft-dB) (fft-linear)    ;choose fft amplitude axis scaling (log or linear)\n\
 (fft-log-freq)           ;choose fft frequency axis scaling (log or\n\
    (fft-linear-freq)     ;  linear)\n\
 (subsampling-on)         ;turn data subsampling on or\n\
    (subsampling-off)     ;  off\n\
 (silent-cursor)          ;turn minibuffer info about cursor position off or\n\
    (verbose-cursor)      ;  on\n\
\n\
          ;; Snd as a whole\n\
 (fit-data)               ;show full file and match y axis to data excurion or\n\
   (dont-fit-data)        ;  show first .1 secs and use y axis limits of -1.0 to 1.0\n\
 (default-output-type n)  ;region temp file header choice\n\
 (disconnect)             ;close IPC fifos (named pipes)\n\
 (clear-inputs)           ;try to turn off soundcard input lines (Linux)\n\
\n\
          ;; Sound window\n\
 (sound file)             ;return the sound data in file (for CLM)\n\
 (data beg num)           ;return data in current channel (for CLM)\n\
 (goto-sound file)        ;select file\n\
 (goto-channel file chan) ;select channel of file\n\
 (select-sound n)         ;select the nth sound in the current sound list\n\
 (select-channel n)       ;select channel n in current sound\n\
 (sync) (unsync)          ;set or unset sync button of currently selected sound\n\
 (save-controls)          ;save or\n\
   (restore-controls)     ;   restore the control panel settings\n\
 (amp-env beg dur scl env);apply amp env to current synced channels\n\
                          ;   from beg for dur (both in samples) scaled by scl\n\
 (filter-env order env)   ;apply env as frequency response curve\n\
 (amp-envelope env)       ;same as amp-env but assume 0 to end with scl=1.0\n\
 (selection-amp-envelope env)\n\
 (scale-by ...)           ;amplitude scaling\n\
 (scale-to ...)           ;amplitude scaling\n\
 (src env-or-num)         ;change srate by num or envelope\n\
\n\
          ;; Channel window\n\
 (x-axis low high)        ;set x axis bounds\n\
 (y-axis max)             ;set y axis max (normally 1.0)\n\
 (axes x0 x1 y0 y1)       ;set x and y axis bounds (floats)\n\
 (maxamp)                 ;return current channel maxamp\n\
 (save-marks)             ;write current marks (sound-relative) to filename.marks\n\
 (goto-mark name)         ;move cursor to named mark\n\
 (mark name)              ;return sample associated with named mark\n\
 (delete-mark)            ;delete mark at cursor\n\
 (setf (mark name) sample);place mark at sample\n\
 (show-fft) (hide-fft)    ;show or hide the fft window\n\
 (show-wave) (hide-wave)  ;show or hide the time-domain waveform\n\
\n\
          ;; various browsers\n\
 (preload directory)      ;add sounds in directory to previous files list\n\
                          ;  (preload .) -> preload current directory\n\
 (preload-files-browser list-of-files)\n\
                          ;put list of files in previous files list\n\
                          ;  (preload-file-browser pistol.snd fyow.snd)\n\
 (raw-sound srate chans format defaults)\n\
                          ;set raw data file defaults\n\
 (color-dialog width height)\n\
                          ;start the color dialog (size = width by height)\n\
 (orientation-dialog width height)\n\
                          ;start the orientation dialog\n\
 (file-dialog width height)\n\
                          ;start the file browser\n\
 (just-sounds) (all-files);in the file selection box, either set\n\
                          ;  or unset the just-sounds button\n\
\n\
          ;; regions\n\
 (region n)               ;return data of region n\n\
 (setf-region low high)   ;define region from sample low to high\n\
 (insert beg num)         ;insert data at beg for num samples\n\
 (change beg num)         ;change data (new data follows)\n\
 (delete beg num)         ;delete section from beg for num\n\
 (temp-dir dir)           ;set the temporary file directory to dir\n\
 (scale-selection-by ...) ;region amplitude scaling\n\
 (scale-selection-to ...) ;region amplitude scaling\n\
 (copy)                   ;copy region to X/Motif clipboard (normally disabled)\n\
\n\
          ;; keyboard\n\
 (command cmd state)      ;mimic keyboard cmd, state: control/shift/meta (4/1/8)\n\
 (key key state)          ;key = char here, not ASCII as in command\n\
 (global-set-key key val) ;map key (no control/meta bits) to macro named val\n\
 (global-unset-key key)   ;unmap key (applies only to keystroke without control or meta bits)\n\
\n\
          ;; parser\n\
 (defvar a b)             ;declare a with value b (b can be a list to define an envelope)\n\
                          ;(defvar env1 '(0 0 1 1 2 0)) or (defvar three 3.0)\n\
 (float a)                ;declare a new variable\n\
 (session file)           ;save current Snd state as text file of commands\n\
 (load file)              ;load a file of these commands\n\
                          ;  (e.g. continue earlier session or get saved macros)\n\
\n\
 (load-function lib fun)  ;load external function from shared library\n\
 (function fun)           ;call the external function\n\
\n\
 (save-macros)            ;save all current macros at end of init file\n\
 (save-macro name)        ;save the current macro under name\n\
 (eval expr)              ;send expr to the C-style parser/evaluator\n\
 (tickle-clm)             ;try to unwedge a stuck CLM-Snd interface\n\
 (report-in-minibuffer str) ;print str in minibuffer of currently active sound\n\
 (append-to-minibuffer str) ;append str to minibuffer contents\n\
\n\
The variables that Snd recognizes (in this case) are:\n\
\n\
   cursor x                     ;cursor sample number\n\
   y                            ;value of sample at cursor\n\
   window-height window-width   ;Snd overall window size (pixels)\n\
   fft-window fft-size fft-beta ;various fft choices\n\
   normalize-fft                ;whether to normalize fft data to 1.0\n\
   zero-pad                     ;fft zero padding factor (default 0 = none)\n\
   dot-size                     ;if using dots, dot size in pixels\n\
   line-size                    ;number of samples for line-oriented commands\n\
   y-max                        ;y axis limit\n\
   remember-state               ;auto-save flag\n\
   combine-channels             ;combined channels flag\n\
   auto-open                    ;should newly opened file view be normalized\n\
   x-axis-style                 ;seconds, samples, etc\n\
   speed-style                  ;speed control interpretation (0=float, 1=ratio, 2=semitones)\n\
   speed-tones                  ;octave divisions for semitone calculation above\n\
   initial-x0/x1/y0/y1          ;initial axis bounds when file is first read in\n\
                                ;  if initial-x1 == 0, the full file is displayed\n\
   xmax,xmin,ymax,ymin          ;max axis settings\n\
   movies                       ;update waveform as mix console moves\n\
   mix-duration-brackets        ;show mix segment extent\n\
   mix-amp-scaler mix-speed-scaler mix-tempo-scaler\n\
   overwrite-check              ;overwriteCheck resource\n\
   read-only                    ;sound-relative read-only flag\n\
   auto-resize                  ;autoResize resource as variable\n\
   filter-env-order             ;FIR filter order used by envelope editor\n\
   src-width                    ;sampling rate conversion data table width (default=10)\n\
   env-clipping, env-graphing, env-style ;envelope editor toggle buttons (style: 0=amp, 1=spectrum, 2=srate)\n\
\n\
        ;; the various control panel settings:\n\
   expand-button contrast-button reverb-button filter-button\n\
   amp speed contrast expand revscl revlen filter-order filter\n\
\n\
        ;; associated, but undisplayed variables\n\
   explen exprmp exphop revfb revlp contrast-amp revdecay follow-play\n\
        ;; there are also global versions of some of these (prepend 'global-')\n\
\n\
        ;; color and orientation settings\n\
   color-scale sono-max spectro-[xyz]angle spectro-[xyz]scl\n\
   wavo-hop wavo-trace spectro-hop\n\
   color-cutoff color-inverted spectro-color sono-color\n\
\n\
        ;; raw (no header) file descriptions\n\
   raw-srate raw-chans raw-format raw-defaults header-type\n\
\n\
        ;; record window settings\n\
   record-srate record-chans record-type record-format\n\
   record-autoload record-digital record-line-panel\n\
   record-out-panel record-mic-panel\n\
        ;; and the 16 sliders\n\
   record-[line|mic|out]-[a|b|aa|ab|bb|ba]\n\
\n\
The operations setf, setq, incf, and decf can be\n\
used to change these variables. 'cursor' refers\n\
to the position of the currently active cursor.\n\
'window-height' and 'window-width' refer to the\n\
overall main Snd window. The 'x-axis-style'\n\
variable controls the ticks and labels on the x\n\
axis. The default (0) is to display seconds;\n\
x-axis-style of 1 displays samples, 2 displays\n\
the current window in terms of 0.0 to 1.0 (where\n\
1.0 is the end of the file) -- a sort of\n\
percentage. The 'speed-style' variable controls\n\
interpretation of the control panel's srate\n\
slider: as a float (the default = 0), a small\n\
integer ratio (1) or a semitone\n\
(2). 'speed-tones' sets the number of equal\n\
divisions of the octave in the 'semitone' case\n\
(normally 12).\n\
\n\
The spectrum data is usually normalized to fit\n\
between 0.0 to 1.0; if you'd rather have\n\
un-normalized data (the y-axis in this case\n\
changes to reflect the data values, to some\n\
extent), set the variable normalize-fft to 0.\n\
\n\
As an example of an initialization file, say we\n\
always want the fft graph with its associated\n\
peaks displayed; and the file browser to default\n\
to listing only sound files; and any multichannel\n\
file to combine its channels into one graph. We\n\
create the file \"~/.snd\" and place in it:\n\
\n\
(show-peaks)\n\
(show-fft)\n\
(just-sounds)\n\
(setf combine-channels 1)\n\
\n\
The peaks command opens a help window with the\n\
fft peak information, including the unscaled,\n\
linear amplitudes.\n\
\n";

char *get_init_file_help(void) {return(init_file_help);}

static char resource_help[] =
"I'm not a big fan of X's notion of\n\
resources, since I can't disambiguate\n\
the weird syntax; but if you'd like to\n\
change the colors or fonts used, the\n\
Snd-specific resources (for the SGI) are:\n\
\n\
initFile       \"~/.snd\"\n\
backupFile     \".snd-backup\"\n\
epsFile        \"snd.eps\"\n\
overwriteCheck 0\n\
groups         6\n\
autoResize     1\n\
\n\
buttonFont     -*-times-medium-r-*-*-14-*-*-*-*-*-iso8859-1\n\
boldbuttonFont -*-times-bold-r-*-*-14-*-*-*-*-*-iso8859-1\n\
axisLabelFont  -*-times-medium-r-normal-*-20-*-*-*-*-*-iso8859-1\n\
axisNumbersFont -*-courier-medium-r-normal-*-14-*-*-*-*-*-iso8859-1\n\
helpTextFont    9x15\n\
\n\
useSchemes      none\n\
lightestcolor   ivory1\n\
basiccolor      ivory2\n\
darkcolor       ivory3\n\
darkestcolor    ivory4\n\
textcolor       lightsteelblue1\n\
cursorcolor     cyan ! (in Linux: red)\n\
selectioncolor  ivory4\n\
mixercolor      lightgreen\n\
groupcolor      red\n\
\n\
If you use schemes, the color resources are ignored.\n\
Also, the LIBS statement in the Snd makefile is\n\
different if you choose to use schemes.  If you\n\
use schemes with the simpler LIBS statement, Snd\n\
will die with complaints about corrupt data.\n\
\n\
See Snd.ad.\n\
\n";

char *get_resource_help(void) {return(resource_help);}


static char region_browser_help[] =
"This is the 'region browser'.  The scrolled\n\
window contains the list of current regions\n\
with a brief title to indicate the provenance\n\
thereof, and two buttons.  The 'save' button\n\
protects or unprotects the region from deletion.\n\
The 'play' button plays the associated region.\n\
One channel of the currently selected region\n\
is displayed in the graph window.  The up and\n\
down arrows move up or down in the region's\n\
list of channels.  If you click a region's\n\
title, the text is highlighted, and that region\n\
is displayed in the graph area.  You can cause\n\
that region to become the current 'selection'\n\
by clicking the 'Select' button (this merely\n\
moves the region to the top slot in the region\n\
list).  You can delete the selected region by\n\
clicking the 'Delete' button.  To dismiss the\n\
browser, click 'Ok'.\n\
\n";

char *get_region_browser_help(void) {return(region_browser_help);}


static char ufun_help[] = 
"User functions are external functions, loaded\n\
into a shared library or shared object file.\n\
They can be loaded into Snd at any time and\n\
thereafter called via the commands given below.\n\
These functions have access to all the sound\n\
data and can operate on it in many ways.\n\
Due to limitations in shared object files,\n\
the communication path between Snd and a\n\
user function is somewhat peculiar.\n\
\n\
There are several examples of user functions\n\
in the Snd source file snd-ufunex.c, normally\n\
loaded into sndlib.so during the Snd make process.\n\
These examples should give an idea of how to add\n\
your own favorite functions to Snd.\n\
\n\
The interface is defined in snd-ufun.h; briefly,\n\
a user function is loaded via C-X C-L or the\n\
command (load-function).  In both cases the\n\
arguments are the library name (no quotes)\n\
followed by the function name (no quotes).\n\
For example, the rms function in snd-ufunex.c\n\
can be loaded into Snd with:\n\
\n\
C-X C-L sndlib.so,rms\n\
\n\
Once loaded, the function can be invoked with\n\
\n\
C-X C-H rms\n\
\n\
and thereafter with C-H.  If instead, you\n\
invoke the function with C-X C-Y, the function\n\
will be called automatically thereafter each time\n\
the data in the channel window changes.  This can\n\
be cancelled by giving a '-' argument to C-X C-Y.\n\
To apply the function to the current selection,\n\
use C-X h or C-X y.  Arguments can be passed to\n\
the user function:\n\
\n\
C-X C-H a_func(4,3.14)\n\
\n\
See snd-ufunex.c if you're interested in writing\n\
one of these functions.\n\
\n\
";

char *get_ufun_help(void) {return(ufun_help);}


static char mixing_help[] =
"Since mixing is the most common and most useful\n\
editing operation performed on sounds, there is\n\
relatively elaborate support for it in Snd. Each\n\
individual mix portion has a mix console, a\n\
small box displayed in above the waveform\n\
containing various controls. These consoles\n\
follow the sync buttons where relevant. More\n\
importantly, consoles can be edited together by\n\
collecting related mix portions into a group,\n\
then firing up the Group Editor (via the View\n\
menu Groups option). In a sense, a group can be\n\
viewed as Snd's way of implementing a more normal\n\
mixer's tracks.\n\
\n\
To mix in a file, use either the File Mix menu\n\
option or the command C-x C-q. Currently the only\n\
difference between these two is that the Mix menu\n\
option tries to take the current sync state into\n\
account, whereas the C-x C-q command does not. To\n\
mix a selection, use C-x q. The mix starts at the\n\
current cursor location.\n\
\n\
When a section or file is mixed into the current\n\
file a mix console is associated with it, each\n\
output channel getting its own console. The\n\
console is displayed at first as a row of widgets\n\
giving the input file name, the begin and end\n\
times of the mixed-in portion (click to change\n\
from seconds to samples), then three icons:\n\
\n\
  a speaker:   while pushed, the input is played\n\
  an 'x':      click to remove the console permanently\n\
  a box:       click to open (or close) the console\n\
\n\
You can drag the widgets to change the position\n\
of the mix. Once opened, each console presents a\n\
pane with an amplitude slider for each input\n\
channel, and a speed control (srate change on the\n\
input). The initial state of the console sets the\n\
speed to 1.0, and all the input amplitudes 0.0\n\
except the channel that matches the current\n\
output channel, which is set to 1.0 (a straight\n\
mix). To return to this state at any time, click\n\
the 'amp:' label. To turn the mix off ('mute' it,\n\
set all amps to 0.0), double click the label; to\n\
return to the last settings you made, click it\n\
with control or meta down. Similarly, click the\n\
'speed:' label to reset it to 1.0, and click it\n\
with control or meta to return to your last\n\
settings. Each time you release the mouse button\n\
(or click the amp label) counts as another 'edit'\n\
of the file, so it is usually better to use\n\
'undo' and 'redo' in this context, rather than\n\
repeated clicks and shift-clicks. The srate scale\n\
is interpreted in the same way as the sound pane\n\
speed control -- as a float normally, but also,\n\
if you like, quantized to semitones or integer\n\
ratios.\n\
\n\
To change the scale interpretation, set the\n\
variables mix-amp-scaler, mix-speed-scaler, and\n\
in the group editor mix-tempo-scaler; all default\n\
to 1.0 which gives a scaling from 0 to around\n\
12. These numbers actually scale an exponent, so\n\
(for example) if mix-amp-scaler is set to 0.5,\n\
the scale goes from 0.0 to around 3.5; similarly\n\
if mix-tempo-scaler is 0.025, its scale goes from\n\
around .95 to 1.05.\n\
\n\
To reduce the mix console to the single letter\n\
'M', double click the file name. Double click the\n\
'M' to return to the original row of icons. Since\n\
screen space is at a premium, this minimal form\n\
of the console can reduce clutter. You can still\n\
drag the 'M' to reposition the mix.\n\
\n\
When any edit is performed that changes the file\n\
within the mixed portion, the affected mix\n\
consoles are removed from the display, and the\n\
only way to return to them is to undo the\n\
offending edit. That is, if you mix a portion,\n\
then cut some part of that portion, the mix will\n\
be locked in place from then on, as if you had\n\
clicked the 'x' button on the mix console.\n\
\n\
To turn off the constant graphics updates (which\n\
can slow down old machines like mine, and which\n\
can also be annoying when you know what you're\n\
doing), set the variable movies to 0 (it is also\n\
accessible in the Group Editor).\n\
\n\
When a sound is mixed into a file that has its\n\
sync button on, the separate channels are tied\n\
together so that as long as the sync button is\n\
on, if you move one mix console the other sync'd\n\
consoles move with it. Similarly, any speed\n\
change is reflected automatically in the other\n\
consoles; amplitude changes however, are not\n\
copied. To make the sync'd consoles independent,\n\
turn off the sync button. Once unsync'd, the\n\
consoles remain independent unless you 'undo'\n\
enough edits to return to the sync'd state.\n\
\n";
char *get_mixing_help(void) {return(mixing_help);}

static char grouping_help[] = 
"To tie together an arbitrary collection of mix\n\
consoles, use the 'group' buttons in the upper\n\
right corner of the mixer. Any mixers that share\n\
a button can be changed in parallel using the\n\
Group Editor (the Groups option under the View\n\
menu). The group editor gives amplitude control\n\
over each output channel that has a mix that is\n\
a member of the group. The speed control affects\n\
the sampling rate, and the tempo control affects\n\
the spacing of the individual members of the\n\
group. The play button plays just the group\n\
members.\n\
\n\
The group editor envelope fields use the same\n\
syntax as other Snd envelopes: (0 0 1 1) is a\n\
ramp, for example, and (0 0 1 1 2 0) is a sort\n\
of pyramid. The envelope data in a given field\n\
only takes effect after the field has been\n\
activated (normally by a carriage return). The\n\
tempo envelope is interpreted in terms of the\n\
current group times using the placement of the\n\
given mix within the group to find the parallel\n\
place on the (arbitrary) tempo envelope x axis.\n\
The value of the envelope at that point becomes\n\
another tempo multiplier; that is, these\n\
envelopes are not time maps (perhaps someday!).\n\
Since a tempo value of 2 makes things happen\n\
twice as slowly (it essentially multiplies begin\n\
times), the tempo envelope causes things to go\n\
faster as it gets closer to zero -- weird!\n\
\n\
The underlying mix consoles have independent\n\
envelopes, but my original plan to include\n\
envelope text fields in the consoles made them\n\
too big, cluttered, and unwieldy; an attempt to\n\
make each console a scrollable (or paned) window\n\
failed due to unfortunate limitations in\n\
Motif. These could be overcome, but would\n\
require much more programming than I think the\n\
issue is worth. I'm interested in better ideas,\n\
if anyone has any. One idea I'm goofing around\n\
with makes the mix matrix entries visicalc-like\n\
expressions.\n\
\n\
Since a mix is viewed in Snd as just another\n\
edit which you can undo and redo, and since one\n\
mix console can be participating in any number\n\
of groups, and since any number of files can\n\
have these grouped mixes active at once, and\n\
since you can ungroup a mix, then undo the\n\
related edit, it becomes a bit of a pain to\n\
describe what each sequence of actions will do.\n\
In general, think of a group as simply another\n\
kind of 'sync' button. The Group Editor itself\n\
does not follow the undo/redo chains (edits in\n\
Snd are considered to be local to each channel,\n\
but the group editor affects all mixes together,\n\
possibly across many channels). Each change to a\n\
group control immediately affects all mixes\n\
associated with that group, in each case as a\n\
single edit of each participating channel. Each\n\
change to the mix console takes into account the\n\
state of the groups that it is a member of.\n\
Undo of any edit simply undoes the edit -- the\n\
mix console will back up one state, but if the\n\
group controls have changed in the meantime, the\n\
two are now out of sync. Similarly, if you\n\
remove a mix from a group, the group's effect\n\
upon the mix is removed as well. If it joins a\n\
group with current state, that causes an\n\
immediate change in the mixed portion's\n\
state. The tempo control, however, only affects\n\
mixes that are under its control when it is\n\
changed (does that make sense? -- the idea is\n\
that you might want to leave a group briefly to\n\
fix a local mix position or speed, then rejoin\n\
the group, but in that process you don't want\n\
the tempo control to cause the mix to jump about\n\
randomly in time). Similar complications affect\n\
the group envelopes. You can choose whether the\n\
envelope is applied over the entire output\n\
duration, or just the group duration; in the\n\
latter case, you need to be aware that adding or\n\
removing mixes can change that duration,\n\
changing the effect of the envelope. Group state\n\
changes by themselves are not edits (i.e. if a\n\
group has no members, undo and redo will not\n\
notice that you've been fiddling with its amp\n\
scalers). If a mix is participating in several\n\
groups, all associated groups affect the mix\n\
together (group states are multiplied, and\n\
envelopes are melded into something resembling a\n\
gathering of the various envelopes). If a mix is\n\
synced to others, and joins or leaves a group,\n\
all the synced mixes follow its lead. All of\n\
this can be summarized: groups act like the sync\n\
buttons. And if it's confusing, consider the\n\
alternatives; or better, decide once and for all\n\
which mixes are grouped together, and use only\n\
one group per mix. Then everything should be\n\
intuitive.\n\
\n\
";
char *get_grouping_help(void) {return(grouping_help);}


static char recording_help[] = 
"To make a recording, choose 'Record'\n\
from the File menu.  The top three panes\n\
display the status of the input and\n\
output lines.  If a channel is active,\n\
its meter will glow yellow.  If some\n\
signal clips during recording, the meter\n\
will flash red.  The numbers below the\n\
channel buttons indicate the signal\n\
maximum since it was last reset.  The\n\
sliders underneath scale the audio data in\n\
various ways before it is mixed into the\n\
output.  The vertical sliders on the right\n\
scale the line-in and microphone signals\n\
before the meter, and the output signal\n\
before it gets to the speaker (these are\n\
needed to avoid clipping on input, and to\n\
set the 'monitor' volume of the output\n\
independent of the output file volume).\n\
\n\
The fourth pane has information about\n\
the current output file (its name and so\n\
on), and the layout of the window.  The\n\
buttons on the right can be used to open\n\
and close panes painlessly.  The fifth\n\
window contains a history of whatever\n\
the recorder thought worth reporting.\n\
The duration field gives the current\n\
output file's duration.  The bottom row\n\
of buttons dismiss the window, start\n\
recording, cancel the current take, and\n\
provide some help.\n\
\n\
To make a recording, choose the inputs\n\
and outputs you want; for example, to\n\
record channel A from the microphone to\n\
channel A of the output file, click the\n\
Microphone panel's A button and the\n\
Output panel's A button.  Then when\n\
you're ready to go, click the Record\n\
button.  Click it again to finish the\n\
recording.\n\
\n\
Digital input is slightly tricky -- you\n\
need to set the sampling rate before you\n\
click the 'digital input' button; otherwise\n\
you'll get a stuttering effect because the output\n\
(monitor) rate doesn't match the input rate.\n\
On the SGI, digital input turns off the mic\n\
input, and the vertical line-in sliders affect\n\
only analog line-in (apparently).\n\
";

char *get_recording_help(void) {return(recording_help);}


static char envelope_editor_help[] = 
"The Edit Envelope dialog (under the Edit menu)\n\
fires up a window for viewing and editing\n\
envelopes. The dialog has a display showing either\n\
the envelope currently being edited or a panorama\n\
of all currently loaded envelopes. The current\n\
envelope can be edited with the mouse: click at\n\
some spot in the graph to place a new breakpoint,\n\
drag an existing breakpoint to change its\n\
position, and click an existing breakpoint to\n\
delete it. The Undo and Redo buttons can be used\n\
to move around in the list of envelope edits; the\n\
current state of the envelope can be saved with\n\
the 'save' button, or printed with 'print'.\n\
\n\
Envelopes can be defined using defvar, and loaded\n\
from a separate file of envelope definitions via\n\
the Session dialog's Load command. For example,\n\
the file:\n\
\n\
  (defvar ramp '(0 0 1 1))\n\
  (defvar pyramid '(0 0 1 1 2 0))\n\
\n\
defines two envelopes that can be used in Snd\n\
wherever an envelope is needed (e.g. C-x C-a). You\n\
can also define a new envelope in the dialog's\n\
text field; '(0 0 1 1) followed by return fires up\n\
a ramp as a new envelope.\n\
\n\
In the overall view of envelopes, click an\n\
envelope, or click its name in the scrolled list\n\
on the left to select it; click the selected\n\
envelope to load it into the editor portion,\n\
clearing out whatever was previously there.  To\n\
load an exisiting envelope into the editor, you\n\
can also type its name in the text field; to give\n\
a name to the envelope as it is currently defined\n\
in the graph viewer, type its name in this field,\n\
then either push return or the 'save' button.\n\
\n\
Once you have an envelope in the editor, it can be\n\
applied to the currently active sounds via the\n\
'Apply' or 'Undo&Apply' buttons; the latter first\n\
tries to undo the previous edit, then applies the\n\
envelope. The envelope can be applied to the\n\
amplitude, the spectrum, or the sampling rate. The\n\
choice is made via the three buttons marked 'amp',\n\
'flt', and 'src'. The filter order is the variable\n\
filter-env-order which defaults to 40. (The\n\
equivalent M-X function is (filter-env order\n\
env)). The sampling rate conversion sinc width is\n\
the variable src-width which defaults to 10 (the\n\
equivalent M-X function is (src env)). To\n\
interrupt the application of the envelope, click\n\
the 'Stop' button.\n\
\n\
The two toggle buttons at the lower right choose\n\
whether to show a light-colored version of the\n\
currently active sound (the 'wave' button), and\n\
whether to clip mouse movement at the current y\n\
axis bounds (the 'clip' button).\n\
";

char *get_envelope_editor_help(void) {return(envelope_editor_help);}

