/* strings used in Snd. 
 *
 * Why not X resources? To use labelString resources here, rather than C macros, is X-specific, and complicated;
 *   resources are trying to implement different versions while hiding code, but all Snd code is public.
 *   The widget names and hierarchy may change without notice, since I don't consider that level of
 *   the code to be part of a public interface.  Some widgets are un-named.  Setting default resource values,
 *   and passing these strings to all portions of the program is a logistical nightmare.  Using XPG/3 string
 *   catalogs strikes me as an even worse kludge. And finally, many of the menu labels are context-dependent.
 *
 * Since some of these strings are trying to provide formatted information, it seemed
 *   better to include the entire format specification, since otherwise I'm assuming
 *   quasi-English (mid-20th century downtown Oklahoma City American) syntax.
 */

#define snd_string_decimal                      '.'
/* defines the decimal point character used where I'm making float representations by hand */

/* '_p' below means it's a prompt */

#define snd_string_Apply			"Apply"
#define snd_string_Autoload_Recording           "Autoload Recording"
#define snd_string_Big_Trouble                  "Yow! Big Trouble!"
#define snd_string_Cancel			"Cancel"
#define snd_string_Channel_style                "Channel style"
#define snd_string_Chebyshev                    "Chebyshev"
#define snd_string_Clear                        "Clear"
#define snd_string_Click_for_help		"Click for help"
#define snd_string_CLM                          "CLM"
#define snd_string_Close			"Close"
#define snd_string_Color                        "Color"
#define snd_string_Color_Editor                 "Color Editor"
#define snd_string_Contrast			"Contrast"
#define snd_string_Customization		"Customization"
#define snd_string_Cut				"Cut"
#define snd_string_Default			"Default"
#define snd_string_Delete			"Delete"
#define snd_string_Digital_Line_In              "Digital Line In"
#define snd_string_Dismiss		        "Dismiss"
#define snd_string_Done				"Done"
#define snd_string_Dots				"Dots"
#define snd_string_Edit				"Edit"
#define snd_string_Edit_Envelope                "Edit Envelope"
#define snd_string_Edit_History                 "Edit History"
#define snd_string_Envelope			"Envelope"
#define snd_string_Error			"Error"
#define snd_string_Exit				"Exit"
#define snd_string_Expand			"Expand"
#define snd_string_FFT			        "FFT"
#define snd_string_FFT_beta			"FFT beta"
#define snd_string_FFT_in_dB			"FFT in dB"
#define snd_string_FFT_linear			"FFT linear"
#define snd_string_FFT_linear_freq		"FFT linear freq"
#define snd_string_FFT_log_freq			"FFT log freq"
#define snd_string_FFT_Orientation		"FFT Orientation"
#define snd_string_FFT_size			"FFT size"
#define snd_string_FFT_style			"FFT style"
#define snd_string_FFT_window			"FFT window"
#define snd_string_FFT_Window_Parameter		"FFT window parameter"
#define snd_string_File				"File"
#define snd_string_File_Browser                 "File Browser"
#define snd_string_File_Out                     "File Out"
#define snd_string_Files			"Files"
#define snd_string_Find				"Find"
#define snd_string_Focus_style                  "Zoom focus"
#define snd_string_Format			"Format"
#define snd_string_Formats			"Formats"
#define snd_string_Fourier                      "Fourier"
#define snd_string_Groups                       "Groups"
#define snd_string_Group_Editor                 "Group Editor"
#define snd_string_Hankel                       "Hankel"
#define snd_string_Help				"Help"
#define snd_string_Hide_consoles                "Hide consoles"
#define snd_string_Hide_controls		"Hide controls"
#define snd_string_Hide_marks			"Hide marks"
#define snd_string_Hide_peaks			"Hide peaks"
#define snd_string_Hide_Y0			"Hide Y=0"
#define snd_string_Info			        "Info"
#define snd_string_Just_FFT			"Just FFT"
#define snd_string_Legendre                     "Legendre"
#define snd_string_Line_In                      "Line In"
#define snd_string_Line_Panel                   "Line Panel"
#define snd_string_Lines			"Lines"
#define snd_string_Load                         "Load"
#define snd_string_Marks			"Marks"
#define snd_string_Mic_Panel                    "Mic Panel"
#define snd_string_Microphone                   "Microphone"
#define snd_string_Mix		                "Mix"
#define snd_string_Mixing                       "Mixing"
#define snd_string_Mix_Preferences              "Mix Preferences"
#define snd_string_Mix_Selection		"Mix Selection"
#define snd_string_New				"New"
#define snd_string_No_Header_on_File		"No Header on File"
#define snd_string_No_header_found_for		"No header found for %s"
#define snd_string_Normalize			"Normalize"
#define snd_string_Ok				"Ok"
#define snd_string_Open				"Open"
#define snd_string_Options			"Options"
#define snd_string_Orientation                  "Orientation"
#define snd_string_Output_Panel                 "Output Panel"
#define snd_string_Overview			"Overview"
#define snd_string_Paste			"Paste"
#define snd_string_Play				"Play"
#define snd_string_Play_selection		"Play selection"
#define snd_string_Print			"Print"
#define snd_string_Raw_Data			"Raw Data"
#define snd_string_Record			"Record"
#define snd_string_Recording			"Recording"
#define snd_string_Redo				"Redo"
#define snd_string_Region_Browser		"Region Browser"
#define snd_string_Regions			"Regions"
#define snd_string_Replay			"Replay"
#define snd_string_Reset                        "Reset"
#define snd_string_Restart		        "Restart"
#define snd_string_Reverb			"Reverb"
#define snd_string_Revert			"Revert"
#define snd_string_Save				"Save"
#define snd_string_Save_as			"Save as"
#define snd_string_Save_options			"Save options"
#define snd_string_Save_selection     	        "Save selection"
#define snd_string_Select			"Select"
#define snd_string_Session                      "Session"
#define snd_string_Show_consoles                "Show consoles"
#define snd_string_Show_controls		"Show controls"
#define snd_string_Show_marks			"Show marks"
#define snd_string_Show_peaks			"Show peaks"
#define snd_string_Show_Y0			"Show Y=0"
#define snd_string_Silent_cursor		"Silent cursor"
#define snd_string_Sonogram			"Sonogram"
#define snd_string_Sound_Files_Only		"sound files only"
#define snd_string_Spectrogram			"Spectrogram"
#define snd_string_Speed			"Speed"
#define snd_string_Speed_style                  "Speed style"
#define snd_string_Stop                         "Stop"
#define snd_string_Subsampling_off		"Subsampling off"
#define snd_string_Subsampling_on		"Subsampling on"
#define snd_string_Sync				"Sync"
#define snd_string_There_is_already_a_mark_at_sample "There is already a mark at sample %d"
#define snd_string_Transform_type               "Transform type"
#define snd_string_Undo				"Undo"
#define snd_string_Undo_and_Apply		"Undo&Apply"
#define snd_string_Undo_and_redo		"Undo and redo"
#define snd_string_Update                       "Update"
#define snd_string_User_functions		"User functions"
#define snd_string_Verbose_cursor		"Verbose cursor"
#define snd_string_View				"View"
#define snd_string_Wavelet                      "Wavelet"
#define snd_string_X_axis_units                 "X axis units"
#define snd_string_always                       "always"
#define snd_string_amp			        "amp"
#define snd_string_amp_p			"amp:"
#define snd_string_amp_env_p			"amp env:"
#define snd_string_amp_m			"   amp:   "
#define snd_string_at                           "at"
/* 'at' used in the phrase 'y = %f at %d' -- reported results from the Find command */
#define snd_string_apply_flushed		"apply flushed!"
/* 'flushed' = interrupted, stopped prematurely (output discarded) */
#define snd_string_applying			"applying..."
#define snd_string_bessie_dumb                  "snd's bes-i0 function does not handle arguments > 15.0"
#define snd_string_beta_p			"beta:"
#define snd_string_cant_allocate_IO_buffers	"can't allocate IO buffers"
#define snd_string_cant_access                  "can't access %s! temp dir is still %s."
#define snd_string_cant_find			"can't find %s"
#define snd_string_cant_find_file		"can't find file"
#define snd_string_cant_find_font               "can't find font %s"
#define snd_string_cant_load			"can't load %s"
#define snd_string_cant_load_from               "can't load %s from %s!"
#define snd_string_cant_open			"can't open %s"
#define snd_string_cant_open_file		"can't open file"
#define snd_string_cant_play			"can't play"
#define snd_string_cant_read			"can't read %s"
#define snd_string_cant_read_header		"can't read header"
#define snd_string_cant_read_his_header		"can't read %s's header"
#define snd_string_cant_record_no_inputs        "can't record: no inputs enabled"
#define snd_string_cant_record_no_outputs       "can't record: no outputs enabled"
#define snd_string_cant_record_no_output_file   "can't record: no output file name supplied"
#define snd_string_cant_record_screwed_up_chans "can't record: you screwed up the output channel number!"
#define snd_string_cant_record_screwed_up_srate "can't record: you screwed up the sampling rate"
#define snd_string_cant_rename_file		"can't rename file"
#define snd_string_cant_remove_file		"can't remove file"
#define snd_string_cant_write			"can't write %s"
#define snd_string_cant_write_p			"can't write %s: %s"
#define snd_string_cant_write_data		"can't write data"
#define snd_string_cant_write_header		"can't write header"
#define snd_string_cant_write_type_with_format  "can't write %s %s file with %s data"
#define snd_string_changed_on_disk_p            "%s changed on disk! Save anyway?"
#define snd_string_channel_id                   "chn"
#define snd_string_chan_cursor_at_sample	"chan %d, cursor at %s (sample %d) = %s"
#define snd_string_chans                        "chans: %d"
#define snd_string_chans_p			"chans:"
#define snd_string_clip			        "clip"
#define snd_string_colormap                     "colormap"
#define snd_string_combined                     "combined"
#define snd_string_comment_p                    "comment:"
#define snd_string_contrast			"contrast:"
#define snd_string_copy                         "copy"
#define snd_string_current_files                "current files"
#define snd_string_current_selection            "current selection"
#define snd_string_cursor_at_sample		"cursor at %s (sample %d) = %s"
#define snd_string_cutoff                       "data cutoff"
#define snd_string_dark                         "dark"
#define snd_string_data                         "data"
#define snd_string_data_format_p		"data format:"
#define snd_string_defining_kbd_macro		"defining kbd macro..."
#define snd_string_defining_region		"defining region..."
#define snd_string_direct_to_printer            "direct to printer"
#define snd_string_display_info                 "srate: %d\nchans: %d\nlength: %.3f\ntype: %s\nformat: %s\nwritten: %s\ncomment: %s\n"
#define snd_string_duration_p                   "duration:"
#define snd_string_edit_env                     "edit env"
#define snd_string_env_p			"env:"
#define snd_string_envelope_editor              "envelope editor"
#define snd_string_envelope_over_output         "envelope over output"
#define snd_string_envs_p			"envs:"
#define snd_string_eps_file_p			"eps file:"
#define snd_string_error                        "error"
#define snd_string_error_reading_file_extra_open_paren "error reading file: extra ')'?"
#define snd_string_eval_p			"eval:"
#define snd_string_exists_overwrite             "%s exists. Overwrite?"
#define snd_string_expand			"expand:"
#define snd_string_f				"f"
/* this 'f' => fft display (should be 1 character) */
#define snd_string_fft_beta                     "fft-beta"
#define snd_string_fft_size                     "fft-size"
#define snd_string_fft_window                   "fft-window"
#define snd_string_file				"file"
#define snd_string_file_has_changed             "file has changed on disk"
#define snd_string_file_p			"file:"
#define snd_string_filter_order			"filter order:"
#define snd_string_find			        "find"
#define snd_string_find_p			"find:"
#define snd_string_find_s			"find: %s"
#define snd_string_float                        "float"
#define snd_string_flt			        "flt"
#define snd_string_flt_env_p			"flt env:"
#define snd_string_focus_active                 "cursor or selection"
#define snd_string_focus_left                   "window left edge"
#define snd_string_focus_middle                 "window midpoint"
#define snd_string_focus_right                  "window right edge"
#define snd_string_frequency			"frequency"
#define snd_string_frequency_reversed           "ycneuqerf"
#define snd_string_function_p			"function:"
#define snd_string_global_search		"global search"
#define snd_string_has_unsaved_edits            "%s has unsaved edits.\nClobber them and overwrite %s?"
#define snd_string_going_on                     "ok -- here we go..."
#define snd_string_header                       "header"
#define snd_string_hop                          "hop"
#define snd_string_insert_file_p		"insert file:"
#define snd_string_invalid_assignment		"invalid assignment"
#define snd_string_invalid_number		"invalid number"
#define snd_string_invalid_srate		"invalid srate: %.3f"
#define snd_string_invert                       "invert"
#define snd_string_is_a_directory               "%s is a directory"
#define snd_string_lag_time			"lag time"
#define snd_string_len				"len:"
#define snd_string_length                       "length: %.3f"
#define snd_string_length_p                     "length:"
/* 'len' => reverb length in the controls panel */
#define snd_string_light                        "light"
#define snd_string_load_p			"load:"
#define snd_string_log_freq			"log freq"
#define snd_string_macro_definition_already_in_progress "macro definition already in progress"
#define snd_string_macro_name_p			"macro name:"
#define snd_string_mark_p			"mark:"
#define snd_string_maxamp                       "maxamp: %.3f"
#define snd_string_maxamp_p                     "maxamp:"
#define snd_string_mix_amp_scaler_p             "mix-amp-scaler:"
#define snd_string_mix_file_p			"mix file:"
#define snd_string_mix_in_p			"mix in:"
#define snd_string_mix_speed_scaler_p           "mix-speed-scaler:"
#define snd_string_no_color_use_white           "can't get %s -- will use white"
#define snd_string_no_color_use_black           "can't get %s -- will use black"
#define snd_string_no_data                      "(no data)"
#define snd_string_no_error			"no error"
#define snd_string_no_room                      "only %d bytes left on disk, can't write %d"
#define snd_string_no_room_but_we_try           "only %d bytes left on disk, changing to 16-bit temp output"
#define snd_string_no_room_go_on_p              "only %d bytes left on disk; continue?"
#define snd_string_no_session_files_found       "no session files found!"
#define snd_string_no_such_function_loaded	"no such function loaded"
#define snd_string_not_enough_args		"not enough args"
#define snd_string_not_found			"not found"
#define snd_string_not_saved_no_name_given      "not saved (no name given)"
#define snd_string_odd_length_env               "odd length envelope definition?"
#define snd_string_open_p                       "open:"
#define snd_string_paste                        "paste"
#define snd_string_percent_of_spectrum          "% of spectrum"
#define snd_string_percentage                   "percentage"
#define snd_string_placed_at_sample		"%s placed at sample %d"
#define snd_string_play				"play"
#define snd_string_play_this_group              "play this group"
#define snd_string_previous_files               "previous files"
#define snd_string_print                        "print"
#define snd_string_print_env                    "print env"
#define snd_string_printing                     "printing %s"
#define snd_string_r				"r"
/* 'r' => restore in controls panel */
#define snd_string_ratio                        "ratio"
#define snd_string_raw_data                     "raw-data"
#define snd_string_read_only			"read-only"
#define snd_string_redo                         "redo"
#define snd_string_regions                      "regions"
#define snd_string_reverb			"reverb:"
#define snd_string_revert			"revert"
#define snd_string_s				"s"
/* 's' => save in controls panel */
#define snd_string_sample			"sample %d"
#define snd_string_samples			"samples"
#define snd_string_save				"save"
#define snd_string_save_as_p			"save as:"
#define snd_string_saving			"saving %s"
#define snd_string_seconds			"seconds"
#define snd_string_semitone                     "semitones"
#define snd_string_separate                     "separate"
#define snd_string_serious_font_trouble         "serious font trouble:  can't even find the %s font!"
#define snd_string_session                      "session"
#define snd_string_session_p                    "session:"
#define snd_string_show_anchor_position         "show anchor position"  
#define snd_string_show_mix_duration            "show mix duration"
#define snd_string_show_waveform_changes_as_mix_changes "show waveform changes as mix changes"
#define snd_string_speed			"speed:"
#define snd_string_speed_m			"   speed:  "
#define snd_string_srate			"srate: %d"
#define snd_string_srate_p			"srate:"
#define snd_string_src                          "src"
#define snd_string_src_env_p                    "src env:"
#define snd_string_superimposed                 "superimposed"
#define snd_string_sync				"sync"
#define snd_string_temp_dir_p			"temp dir:"
#define snd_string_tempo                        "tempo:"
#define snd_string_time				"time"
#define snd_string_time_reversed		"emit"
#define snd_string_too_deeply_nested		"too deeply nested"
#define snd_string_too_many_args		"too many args"
#define snd_string_undo                         "undo"
#define snd_string_unimplemented_operation	"unimplemented operation"
#define snd_string_unite                        "unite"
#define snd_string_unknown		        "unknown"
#define snd_string_unknown_identifier		"unknown identifier"
#define snd_string_unlist                       "unlist"
#define snd_string_unmatched_close_curly	"unmatched '}'"
#define snd_string_unmatched_open_curly		"unmatched '{'"
#define snd_string_unmatched_open_paren		"unmatched '('"
#define snd_string_unsupported_data_format	"unsupported data format"
#define snd_string_unsupported_file_type	"unsupported file type"
#define snd_string_updated                      "updated %s"
#define snd_string_view_envs                    "view envs"
#define snd_string_w				"w"
/* 'w' => wave (time domain) display (should be 1 character) */
#define snd_string_wave			        "wave"
#define snd_string_wavelet_window               "wavelet-window"
#define snd_string_were_getting_short_on_disk_space "disk nearly full: used %d Kbytes leaving %d"
#define snd_string_window_parameter		"window parameter"
#define snd_string_write_failed                 "write failed: %s"
#define snd_string_wrote                        "wrote %s"
#define snd_string_x_axis_not_increasing        "x axis not increasing: %.*f %s %.*f"
#define snd_string_x_angle                      "x angle"
#define snd_string_x_scale                      "x scale"
#define snd_string_y_angle                      "y angle"
#define snd_string_y_scale                      "y scale"
#define snd_string_z_angle                      "z angle"
#define snd_string_z_scale                      "z scale"


