# RPM spec file for Snd

Summary:	A sound editor
Name:		snd
Version:	1
Release:	2
Copyright:	GPL
Group:		Applications/Sound
Source:		ftp://ccrma-ftp.stanford.edu/pub/Lisp/snd.tar.gz
URL:		http://ccrma-www/CCRMA/Software/snd/snd.html
Vendor:		CCRMA/Music Stanford University
Packager:	Bill Schottstaedt

%description
Snd is a sound editor modelled loosely after Emacs and an old, sorely-missed
PDP-10 sound editor named Dpysnd. It can accomodate any number of sounds at
once, each with any number of channels. Each channel is normally displayed
in its own window, with its own cursor, edit history, and marks; each sound
has a 'control panel' to try out various changes quickly, and an expression
parser, used mainly during searches; there is an overall stack of 'regions'
that can be browsed and edited; channels and sounds can be grouped together
during editing; edits can be undone and redone without restriction
('unlimited undo'); Snd can be customized using an Emacs-lisp-like syntax;
it can also be extended with user-supplied editing or display functions
loaded at run time; and it's free; the code is available via anonymous ftp
from ccrma-ftp.stanford.edu as pub/Lisp/snd.tar.gz.

%prep
# snd.tar.gz does not follow the RPM naming or directory expectations
%setup -c -n snd
# need to create snd directory, move to it, untar/unzip (hysteron proteron) snd.tar.gz

%build
%ifos Linux
make -f makefile.rpm
# this version statically links the Motif libraries
%endif
%ifos Irix
make-f makefile.sgi
%endif
# error if neither?

%install
# cp snd /usr/local/bin
install -m 755 -o 0 -g 0 -d /usr/local/bin/
install -m 755 -o 0 -g 0 snd /usr/local/bin/snd

%files
%doc README.Snd
%doc snd.html
%doc snd.txt
%doc title.gif
%doc controls.gif
%doc auto.gif
%doc files.gif
%doc regions.gif
%doc mixer.gif
%doc rec.gif
%doc fft.gif
%doc save.gif
/usr/local/bin/snd

